function [x,i] = GaussSeidel(A,b,x0)

eps=0.0001; %tolerncia do erro relativo
nmax=200;   %nmero mximo de iteraes

P=triu(A);
B=P-A;

melhoria=1; %inicializar melhoria
i=0;        %inicializar contador
x=x0;       %inicializar x

while melhoria > eps && i< nmax
     xnew=P\(B*x+b); %calcular prxima iterao
     
     melhoria=norm(xnew-x)/norm(x); %actualizar melhoria
     i=i+1;                         %actualizar contador
     x=xnew;                        %actualizar x
end

if i==nmax
    error('Nmero de iteraes excedeu o nmero mximo permitido');
end

